unit Unit1;

{$MODE Delphi}

interface

uses
  LCLIntf, LCLType,
  Windows, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, JwaBluetoothAPIs;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  DH: HBLUETOOTH_DEVICE_FIND;
  DP: BLUETOOTH_DEVICE_SEARCH_PARAMS;
  DI: BLUETOOTH_DEVICE_INFO;
  i: Integer;
begin
  Button1.Enabled:= false;
  Application.Minimize;

  try
    ZeroMemory(@DP, SizeOf(BLUETOOTH_DEVICE_SEARCH_PARAMS));
    DP.dwSize:= SizeOf(BLUETOOTH_DEVICE_SEARCH_PARAMS);
    DP.fReturnAuthenticated:= true;
    DP.fReturnRemembered:= true;
    DP.fReturnUnknown:= true;
    DP.fReturnConnected:= true;
    DP.fIssueInquiry:= true;
    DP.cTimeoutMultiplier:= 5;
    DP.hRadio:= 0;

    ZeroMemory(@DI, SizeOf(BLUETOOTH_DEVICE_INFO));
    DI.dwSize:= SizeOf(BLUETOOTH_DEVICE_INFO);
    DH:= BluetoothFindFirstDevice(DP, DI);
    if DH <> 0 then try

      repeat

        for i:= 1 to 3 do if BluetoothGetDeviceInfo(0, DI) = 0 then Break;
        if GetLastError <> 0 then Continue;

        if DI.fAuthenticated then Continue;

        try
          for i:= 1 to 3 do if BluetoothAuthenticateDevice(0, 0, @DI, '1234', 4) = 0 then Break;
          if GetLastError <> 0 then Continue;
        except
        end;

      until not BluetoothFindNextDevice(DH, DI);

    finally
      BluetoothFindDeviceClose(DH);
    end;
  except
  end;

  Button1.Enabled:= true;
end;

end.
